json.courses do
  json.array! @courses do |course|
    json.id course.id
    json.name course.name
    json.avatar_url url_to_avatar(course.teacher)
    json.creator course.teacher.real_name
    json.school course.teacher.school_name
    json.technical_title course.teacher.user_extension.technical_title
    json.course_members_count course.course_members_count
    json.tasks_count get_tasks_count course
    json.visits course.visits
    json.is_public course.is_public
    json.is_accessible @user.present? ? @user.member_of_course?(course) || @user.creator_of_course?(course) : course.is_public == 1
    json.is_end course.is_end
    json.first_category_url module_url(course.course_modules.where.not(module_type: "activity").where(hidden: 0).order(position: :desc).first, course)
  end
end
json.courses_count @courses_count
