import React, { Component } from 'react';

import CoursesHomeCard from "./coursesHomeCard.js"
import axios from 'axios';
import {Input,Pagination,Tooltip} from 'antd';
import './css/CoursesHome.css';


const Search = Input.Search;
class coursesHome extends Component{
  constructor(props) {
    super(props)
    this.state = {
      limit:16,
      page:1,
      order:"all",
      coursesHomelist:undefined,
      search:"",
    }
  }
  //切换列表状态
  changeStatus=(value)=>{
    this.setState({
      order:value,
      page:1
    })

    this.searchcourses(16,1,value,"")
  }
  //搜索输入
  inputSearchValue=(e)=>{

    this.setState({
      search:e.target.value,
      page:1
    })

  }
  //搜索
  searchValue=(e)=>{
    let { search }=this.state;
    this.setState({
      order:'all',
      page:1
    })

    this.searchcourses(16,1,'all',search)

  }

  componentDidMount(){
    this.searchcourses(16,1,"all","")
  }

  onChange=(pageNumber)=> {
    this.setState({
      page:pageNumber
    })
    let {limit,order,search}=this.state;

    this.searchcourses(limit,pageNumber,order,search)

  }

  searchcourses=(limit,page,order,search)=>{
    let url="/courses.json";
    axios.get(url,{
      params: {
        limit:limit,
        page:page,
        order:order,
        search:search
      }
    }).then((result)=>{
      if(result.data.status===401){

      }else{
        this.setState({
          coursesHomelist:result.data
        })
      }

      }).catch((error)=>{
        console.log(error);
      })
  }


  render() {

    let { order,search,page,coursesHomelist }=this.state;

    return (
    <div>

        <div className="newMain clearfix">
            <div className="courses-head pr" >
                <div className="edu-txt-center pathNavLine">
                    <div className="inline path-nav">
                    </div>
                </div>
            </div>

            <div className="mt20 educontent mb20 clearfix">
              <a className={ order == "all" ? "fl mr20 font-16 bestChoose active" : "fl mr20 font-16 bestChoose"}
                   onClick={ () => this.changeStatus("all")}>全部</a>
                <a className={ order == "mine" ? "fl mr20 font-16 bestChoose active" : "fl mr20 font-16 bestChoose"}
                   onClick={ () => this.changeStatus("mine")}>我的</a>
                <a className={ order == "created_at" ? "fl mr20 font-16 bestChoose active" : "fl mr20 font-16 bestChoose"}
                   onClick={ () => this.changeStatus("created_at")}>最新</a>
                <a className={ order == "course_members_count" ? "fl mr20 font-16 bestChoose active" : "fl mr20 font-16 bestChoose"}
                   onClick={ () => this.changeStatus("course_members_count")}>最热</a>

                <div className="fr mr5 search-new">
                    <Search
                    placeholder="课堂名称/教师姓名/学校名称"
                    id="subject_search_input"
                    value={search}
                    onInput={this.inputSearchValue}
                    onSearch={this.searchValue}
                    autoComplete="off"
                    ></Search>
                </div>

            </div>

            <CoursesHomeCard {...this.props} {...this.state}
                             coursesHomelist={coursesHomelist}></CoursesHomeCard>
            {
              coursesHomelist===undefined?"":coursesHomelist.courses_count > 16?
            <div className="educontent mb80 edu-txt-center mt10">
                <Pagination showQuickJumper current={page} pageSize={16} total={coursesHomelist.courses_count} onChange={this.onChange} />
            </div>:""
            }
        </div>

    </div>
    )
  }
}
export default coursesHome;