import React, {Component} from "react";
import CoursesListType from '../coursesPublic/CoursesListType';
import {WordsBtn,ActionBtn} from 'educoder';
import ShixunWorkModal from './Shixunworkdetails/ShixunWorkModal';
import HomeworkModal from "../coursesPublic/HomeworkModal";
import NoneData from '../coursesPublic/NoneData'
import {
	Form,
	Select,
	Input,
	Button,
	Checkbox,
	Upload,
	Icon,
	message,
	Modal,
	Table,
	Divider,
	InputNumber,
	Tag,
	DatePicker,
	Radio,
	Tooltip,
	notification
} from "antd";
import {Link, Switch, Route, Redirect} from 'react-router-dom';
import axios from 'axios';
import '../css/members.css'
import "../common/formCommon.css"
import '../css/Courses.css'
import './style.css'
import moment from 'moment';
import 'moment/locale/zh-cn';

const Search = Input.Search;
const CheckboxGroup = Checkbox.Group;
const qs = require('qs');
//课堂作业设置


//作品列表(教师)
class ShixunStudentWork extends Component {
	constructor(props) {
		super(props);
		this.state = {
			props: props,
			data: undefined,
			page: 1,
			limit:10,
			loadingstate: true,
			order: "code_rate",
			b_order:"desc",
			task_status: [],
			course_group_info: [],
			teacherdata: undefined,
			checkedValuesine: undefined,
			checkedValuesineinfo: [],
			resultint: 0,
			search: undefined,
			visible: false,
			userid: 0,
			visibles: false,
			userids: 0,
			viewtrainingdata: {},
			group_infolist: [],
			duplicatechecking: false,
			datalist:undefined,
			showmodel:false,
			jobsettingsdata:undefined,
		}
	}

	componentDidMount() {
     this.getupdata();
     this.getTrainingjobsetting();
	}
	// 获取数据地方
	getTrainingjobsetting = () => {

		var homeworkid = this.props.match.params.homeworkid;
		let url = `/homework_commons/${homeworkid}/settings.json`;
		axios.get(url).then((result) => {
			if(result !== undefined){
				this.setState({
					jobsettingsdata: result,

				})
			}
	})
	}

	getupdata=()=>{
		var homeworkid = this.props.match.params.homeworkid;
		let url = "/homework_commons/" + homeworkid + "/code_review_results.json";

		axios.get(url).then((response) => {
			if (response.data.status === undefined || response.data.status === 0) {
				if(response.data!=undefined){
					if(response.data.status!=-2){
						let datas=[];
						let list=response.data.users_reviews;
						for(var i=0; i<list.length; i++){
							datas.push({
								number:i+1,
								name:list[i].username,
								stduynumber:list[i].student_id,
								classroom:parseInt(list[i].code_rate),
								operating:list[i].user_id
							})
						}
						this.setState({
							data: response.data,
							datalist:datas
						})
					}

				}
			}

			if (response.data.status === -2) {
				this.setState({
					duplicatechecking: true
				})
			}

			if (response.data.status === -1) {
				notification.open({
					message:"提示",
					description: response.data.message
				});
			}

		}).catch((error) => {
			console.log(error)
		});

		let query = this.props.location.pathname;
		const type = query.split('/');
		this.setState({
			shixuntypes:type[3]
		})
	}

	getcode_review_results=(order,b_order,page,limit,group_infolist,search)=>{
		var homeworkid = this.props.match.params.homeworkid;
		let url = "/homework_commons/" + homeworkid + "/code_review_results.json";

		axios.get(url,{params:{
			  order:order,
				sort:b_order,
				page:page,
				limit:limit,
				group_ids:group_infolist,
				search:search
		},
		paramsSerializer: function(params) {
			return qs.stringify(params, {arrayFormat: 'brackets'})
		}}).then((response) => {
			if (response.data.status === undefined || response.data.status === 0) {
				if(response.data!=undefined){
					if(response.data.status!=-2) {
						let datas = [];
						let list = response.data.users_reviews;
						for (var i = 0; i < list.length; i++) {
							datas.push({
								number: i + 1,
								name: list[i].username,
								stduynumber: list[i].student_id,
								classroom: parseInt(list[i].code_rate),
								operating: list[i].user_id
							})
						}
						this.setState({
							data: response.data,
							datalist: datas
						})
					}

				}
			}

			if (response.data.status === -2) {
				this.setState({
					duplicatechecking: true
				})
			}

			if (response.data.status === -1) {
				notification.open({
					message:"提示",
					description: response.data.message,
				});
			}

		}).catch((error) => {
			console.log(error)
		});
	}


	TablePagination = (e) => {

		this.setState({
			page:e.current
		})

	}

	inputSearchValue=(e)=>{

		if(e.target.value===""){
			this.setState({
				search:undefined
			})
		}else{
			this.setState({
				search:e.target.value
			})
		}


	}

	searchValue=()=>{
		let {order,b_order,page,limit,group_infolist,search} = this.state;
		this.getcode_review_results(order,b_order,page,limit,group_infolist,search)
	}

	funorder=(value)=>{

		let {order,b_order,page,limit,group_infolist,search} = this.state;
		let newb_order;
		if(order===value){
			if(b_order==="desc"){

				this.setState({
					order:value,
					b_order:"asc"
				})
				newb_order="asc";
			}else{

				this.setState({
					order:value,
					b_order:"desc"
				})
				newb_order="desc";
			}
		}else{
			if(b_order==="desc"){

				this.setState({
					order:value,
					b_order:"desc"
				})
				newb_order="desc";
			}else{

				this.setState({
					order:value,
					b_order:"asc"
				})
				newb_order="asc";
			}
		}

		this.setState({
			loadingstate:true,
		})
		this.getcode_review_results(value,newb_order,page,limit,group_infolist,search)

	}
	groupgroup=(checkedValues)=>{
	  let {order,b_order,page,limit,search} = this.state;
		this.setState({
			group_infolist:checkedValues
		})
   this.getcode_review_results(order,b_order,page,limit,checkedValues,search)
	}

	Viewstudenttraininginformation =(list)=>{
		window.location.href =list
	}

	workshowmodel=()=>{
		this.setState({
			showmodel:true
		})
	}

	hideshowmodel=()=>{
		this.setState({
			showmodel:false
		})
	}

	//立即发布
	homeworkstart=()=>{
		let homeworkid=this.props.match.params.homeworkid;
		let url="/homework_commons/"+homeworkid+"/publish_groups.json";

		axios.get(url).then((response) => {

			if(response.status===200){
				let starttime= this.props.getNowFormatDates(1);
				let endtime=this.props.getNowFormatDates(2);
				this.setState({
					modalname:"立即发布",
					modaltype:response.data.course_groups===null||response.data.course_groups.length===0?2:1,
					visible:true,
					Topval:"学生将立即收到作业",
					// Botvalleft:"暂不发布",
					Botval:`本操作只对"未发布"的分班有效`,
					starttime:"发布时间："+moment(moment(new Date())).format("YYYY-MM-DD HH:mm"),
					endtime:"截止时间："+endtime,
					Cancelname:"暂不发布",
					Savesname:"立即发布",
					Cancel:this.homeworkhide,
					Saves:this.homeworkstartend,
					course_groups:response.data.course_groups,
					starttimes:starttime,
					typs:"start",
				})
			}
		}).catch((error) => {
			console.log(error)
		});

	}
	//立即截止
	homeworkends=()=>{
		let homeworkid=this.props.match.params.homeworkid;
		let url="/homework_commons/"+homeworkid+"/end_groups.json";

		axios.get(url).then((response) => {

			if(response.status===200){
				this.setState({

				})
				this.setState({
					modalname:"立即截止",
					modaltype:response.data.course_groups===null||response.data.course_groups.length===0?2:1,
					visible:true,
					Topval:"学生将不能再提交作业",
					// Botvalleft:"暂不截止",
					Botval:`本操作只对"提交中"的分班有效`,
					Cancelname:"暂不截止",
					Savesname:"立即截止",
					Cancel:this.homeworkhide,
					Saves:this.coursetaskend,
					starttime:undefined,
					endtime:undefined,
					typs:"end",
					course_groups:response.data.course_groups,
				})
			}
		}).catch((error) => {
			console.log(error)
		});

	}
// 立即发布
	homeworkstartend=(ds,endtime)=>{
		var homeworkid = this.props.match.params.homeworkid;
		let {course_groupslist} = this.state;

		let coursesId=this.props.match.params.coursesId;
		let url ="/courses/"+coursesId+"/homework_commons/publish_homework.json";
		axios.post(url,{
			homework_ids:[homeworkid],
			group_ids:course_groupslist,
			end_time:endtime,
		}).then((result)=>{
			if(result.status===200){
				if(result.data.status===0){
					notification.open({
						message:"提示",
						description: result.data.message,
					});
					this.homeworkhide()
				}

			}
		}).catch((error)=>{
			console.log(error);
		})
	}

	//立即截止确定按钮
	coursetaskend=()=>{
		var homeworkid = this.props.match.params.homeworkid;
		let {course_groupslist} = this.state;


		const cid = this.props.match.params.coursesId;
		let url="/courses/"+cid+"/homework_commons/end_homework.json";
		axios.post(url, {
				group_ids:course_groupslist,
				homework_ids: [homeworkid],
			})
			.then((response) => {
				if (response.data.status == 0) {
					notification.open({
						message:"提示",
						description: response.data.message,
					});
					this.homeworkhide()
				}
			})
			.catch(function (error) {
				console.log(error);
			});
	}

	getcourse_groupslist=(id)=>{
		this.setState({
			course_groupslist:id
		})
	}

	homeworkhide=()=>{
		this.getupdata()
		this.setState({
			modalname:undefined,
			modaltype:undefined,
			visible:false,
			Topval:undefined,
			Topvalright:undefined,
			Botvalleft:undefined,
			Botval:undefined,
			starttime:undefined,
			endtime:undefined,
			Cancelname:undefined,
			Savesname:undefined,
			Cancel:undefined,
			Saves:undefined,
			StudentList_value:undefined,
			addname:undefined,
			addnametype:false,
			addnametab:undefined,
			typs:undefined,
			starttimes:undefined,
		})
	}


	render() {
		let {
			data,
			search,
			order,
			duplicatechecking,
			datalist,
			page,
			jobsettingsdata,
		} = this.state;
		//
		// let {data}=this.props;


		let columns = [
			{
				title: '序号',
				dataIndex: 'number',
				key: 'number',
				render: (text, record) => (
					<span>
             <a style={{"color": '#07111B', "text-align": "center","margin-left": "10px"}}>{record.number}</a>
        </span>
				)
			},
			{
				title: '姓名',
				dataIndex: 'name',
				key: 'name',
				render: (text, record) => (
					<span>
             <a style={{"color": '#07111B', "text-align": "center"}}>{record.name}</a>
        </span>
				)
			},
			{
				title: '学号',
				dataIndex: 'stduynumber',
				key: 'stduynumber',
				render: (text, record) => (
					<span>
             <a style={{"color": '#9A9A9A', "text-align": "center"}}>{record.stduynumber}</a>
        </span>
				),
			},
			{
				title: '相似度',
				key: 'classroom',
				dataIndex: 'classroom',
				render: (text, record) => (
					<span>
             <a style={{"color": record.classroom>=90?'#FF6800':"#747A7F", "text-align": "center"}}>{isNaN(record.classroom)?"--":record.classroom}%</a>
        </span>
				)
			},
			{
				title: '操作',
				dataIndex: 'operating',
				key: 'operating',
				render: (text, record) => (
					<span>
             <a onClick={()=>this.Viewstudenttraininginformation("/courses/"+this.state.props.match.params.coursesId+"/"+this.state.shixuntypes+"/"+this.props.match.params.homeworkid+"/review_detail/"+record.operating)} >查看</a>
          </span>
				)
			},
		];

		if(this.props.isNotMember()===true){

			columns.some((item,key)=> {
					if (item.title === "学号") {
						columns.splice(key, 1)
						return true
					}
				}
			)

		}

		return (
			<div className="newMain clearfix ">
				{this.state.showmodel===true?<ShixunWorkModal
					{...this.props}
	        visible={this.state.showmodel}
	        modalname={"代码查重"}
					data={data&&data.group_info}
					issCancel={()=>this.hideshowmodel()}
					updatas={()=>this.getupdata()}
        />:""}
				{/*立即发布*/}
				<HomeworkModal
					modaltype={this.state.modaltype}
					modalname={this.state.modalname}
					visible={this.state.visible}
					Topval={this.state.Topval}
					Topvalright={this.state.Topvalright}
					Botvalleft={this.state.Botvalleft}
					Botval={this.state.Botval}
					starttime={this.state.starttime}
					endtime={this.state.endtime}
					Cancelname={this.state.Cancelname}
					Savesname={this.state.Savesname}
					Cancel={this.state.Cancel}
					Saves={this.state.Saves}
					course_groups={this.state.course_groups}
					getcourse_groupslist={(id)=>this.getcourse_groupslist(id)}
					starttimes={this.state.starttimes}
					typs={this.state.typs}
				/>
					<div className={"educontent mb20"}>
						<div className="educontent mb25">
							<p className="clearfix mb25 mt5">
								<ActionBtn className=" btn colorgrey fl hovercolorblue mt5"
													 to={`/courses/${this.props.match.params.coursesId}/students`}>{jobsettingsdata === undefined ? "" : jobsettingsdata.data.course_name}</ActionBtn>
							{/*<ActionBtn className="btn colorgrey fl hovercolorblue" href={"/courses/"+data.course_id+"/students"}>{data.course_name}</ActionBtn>*/}
							<span className="color-grey-9 fl ml3 mr3 mt5">&gt;</span>
								<ActionBtn
									className=" btn colorgrey fl hovercolorblue mt5"
									to={`/courses/${this.props.match.params.coursesId}/${this.state.shixuntypes}/${jobsettingsdata === undefined ? "" : jobsettingsdata.data.category.category_id}`}>{jobsettingsdata === undefined ? "" : jobsettingsdata.data.category.category_name}</ActionBtn>
							{/*<ActionBtn className="btn colorgrey fl hovercolorblue" href={"/courses/"+data.course_id+"/"+this.state.shixuntypes+"/"+this.props.match.params.homeworkid}>实训作业</ActionBtn>*/}
							{/*<ActionBtn className="btn colorgrey fl hovercolorblue" href={"/courses/"+data.course_id+"/"+this.state.shixuntypes+"/"+data.category.category_id}>{data.category.category_name}</ActionBtn>*/}
							<span className="color-grey-9 fl ml3 mr3 mt5">&gt;</span>
							<ActionBtn className="fl">作业详情</ActionBtn>
						</p>
					</div>
						<div className="educontent mb30">
						<p className=" fl color-black  summaryname" style={{heigth:"33px"}}>
							{data&&data.homework_name}
						</p>
						<CoursesListType
							typelist={data&&data.homework_status}
						/>
						<a className="color-grey-9 fr font-16 summaryname  ml20 mr20"
							 href={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${jobsettingsdata === undefined ? "" :jobsettingsdata.data.category.category_id}`}>返回</a>
						<a className={"color-grey-9 fr font-16 mr20"} href={`/shixuns/${jobsettingsdata===undefined?"":jobsettingsdata.data.shixun_identifier}/challenges`} target={"_blank"}>实训详情</a>

					</div>
					<div className="edu-back-white">
						<div className="stud-class-set bor-bottom-greyE ">
							<div className=" clearfix edu-back-white poll_list">

								{/*<Link*/}
								{/*      to={`/courses/${this.state.props.match.params.coursesId}/${this.state.props.match.params.homeworkid}/listofworks`}>作品列表(教师)</Link>*/}
								{this.props.isAdmin() === true?
									<Link  to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/list`}>作品列表</Link>:
									<Link to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/openlist`}>作品列表</Link>

								}
								{/*<Link*/}
									{/*to={`/courses/${this.state.props.match.params.coursesId}/${this.state.props.match.params.homeworkid}/Listofworksstudentone`}>作品列表(学生未完成)</Link>*/}
								{/*<Link*/}
									{/*to={`/courses/${this.state.props.match.params.coursesId}/${this.state.props.match.params.homeworkid}/Listofworksstudenttwo`}>作品列表(学生完成)</Link>*/}
								<Link
									to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/questions`}>作业问答</Link>
								{this.props.isAdmin()?<Link className="active"
								      // to={`/courses/${this.state.props.match.params.coursesId}/${this.state.props.match.params.homeworkid}/student_work`}
									  to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/student_work`}>
								 代码查重</Link>:""}
								<Link
									to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/settings`}
								>设置</Link>
								{this.props.isAdmin() ? <a
									className="fr color-blue font-16"
									href={`/api/homework_commons/${this.props.match.params.coursesId}/works_list.xlsx`}
								>导出</a> : ""}
								{this.props.isAdmin()?
									data&&data.end_immediately===true?
									<a className="fr color-blue font-16" onClick={this.homeworkends}>立即截止</a> : "" : ""}
								{this.props.isAdmin()?
									data&&data.publish_immediately===true?
									<a className="fr color-blue font-16" onClick={this.homeworkstart}>立即发布</a> : "" : ""}

								{/*{this.props.isAdmin()?*/}
									{/*jobsettingsdata&&jobsettingsdata.data.code_review===true?*/}
										{/*<a className="fr color-blue font-16"  onClick={this.workshowmodel}>代码查重</a>*/}
										{/*:"":""}*/}
							</div>
						</div>
						<style>
							{`
							.startbox{
					    height: 48px;
					    background: rgba(255,104,0,0.1);
					    line-height: 48px;
					    text-align: center;
							}

							.startfont{
							 font-size:14px;
							font-family:MicrosoftYaHei;
							font-weight:400;
							color:rgba(255,104,0,1);
							}

							`}
						</style>
						<li className="clearfix startbox mb20" style={{display:duplicatechecking===true?"":"none"}}>
							<span className={"startfont"}>
									正在执行查重，请稍后刷新页面查看结果    温馨提示：执行时间因查重作品数以及作品的代码量而异
							</span>
							<NoneData></NoneData>
						</li>
						<style>
							{`
						  .newbutton{
						      width: 100px;
							    border: 1px solid #29BD8B;
							    color: #29BD8B!important;
						  }
							`}
						</style>

						{data&&data?
						<div>
						<ul className="clearfix" style={{padding: '20px 16px 10px'}}>
							<li className="clearfix ">

								<span   className="fl  mr10 color-grey-8 ">查重时间：{data&&data.last_review_time}</span>
								{this.props.isAdmin()?duplicatechecking===false?<span className="fl ">
									<a  className="Actionbtn newbutton mr20 fl" onClick={this.workshowmodel}>代码查重</a>
								</span>:"":""}
								{/*请输入姓名或学号搜索*/}

								<div className="fr mr5 search-new" style={{marginBottom: '1px'}}>
									<Search
										placeholder="请输入姓名或学号搜索"
										id="subject_search_input"
										autoComplete="off"
										value={search}
										onInput={this.inputSearchValue}
										onSearch={this.searchValue}
									></Search>
								</div>
							</li>


							{/*分班情况*/}

							{data&&data.group_info.length===0?"":<li className="clearfix  mt10">
								<span className="fl mr10 color-grey-8">分班情况：</span>
								<span className="fl ">
									<a id="graduation_comment_no_limit"
										 onClick={()=>this.groupgroup([])}
								     className={this.state.group_infolist.length===0?"pl10 pr10 mr20 check_on":"pl10 pr10 mr20 "}>
										不限
									</a>
								</span>


								<CheckboxGroup onChange={this.groupgroup}
								               value={this.state.group_infolist}
								               style={{paddingTop: '4px'}}>
									{data&&data.group_info === undefined ? "" : data&&data.group_info.map((item, key) => {
										return (
											<span key={key}>
                          <Checkbox value={item.id}className="fl ">
                            <span>
	                            {item.name}({item.members_count})
                            </span>
                          </Checkbox>
                      </span>
										)
									})}
								</CheckboxGroup>

							</li>}

						</ul>


						<div id="graduation_work_list" style={{padding: '0px 16px 10px'}}>

							<div className="clearfix">
                  <span className="fl color-grey-6 font-12">
	                <span className="color-orange-tip">
		                {data&&data.copy_reviews_count}</span>
	                  个疑似抄袭作品（{data&&data.all_reviews_count}作品） </span>

								<div className="fr color-grey-6 edu-menu-panel" style={{color: '#989898'}}>
									<p>
										<a data-remote="true" className={"color-grey-9 font-12"}>
										{order === "code_rate" ? "相似度" : order === "student_id" ? "学号" : ""}
										</a>
										<i className="iconfont icon-xiajiantou ml5 font-12 color-grey-6"></i>
									</p>

									<ul className="edu-menu-list" style={{"width": "80px"}}>
										<li onClick={(e) => this.funorder("code_rate")}>
											<a className={"color-grey-9 font-12"} style={{"text-align": "center "}}>相似度</a>
										</li>
										<li onClick={(e) => this.funorder("student_id")}>
											<a className={"color-grey-9 font-12"} style={{"text-align": "center "}}>学号</a>
										</li>
									</ul>

								</div>

							</div>

						</div>

						<div className={"justify break_full_word new_li edu-back-white"} style={{minHeight: "480px"}}>
							<style>{`
              	          .ant-spin-nested-loading > div > .ant-spin .ant-spin-dot {
																			top: 72%;}
						                }
						              `}</style>
							{datalist === undefined ? "" : <Table
								dataSource={datalist}
								columns={columns}
								pagination={ datalist.length<11?false:{  //分页
									total: datalist.length===0?0:data&&data.all_reviews_count, //数据总数量
									pageSize: 10,  //显示几条一页
									current:page,
								}}

								onChange={this.TablePagination}
							/>}
						</div>

					</div>:""}

				</div></div>




			</div>

		)
	}
}

export default ShixunStudentWork;