import React, { Component } from 'react';

import { SnackbarHOC, getImageUrl, WordsBtn } from 'educoder';
import { Form, Button, Input   } from 'antd'

import '../../courses/css/Courses.css'
import './common.css'

import axios from 'axios'

const PHONE = 'PHONE'
const EMAIL = 'EMAIL'
const PASSWORD = 'PASSWORD'

function regPhoneAndEmail(value){
  if(value.indexOf("@")>-1){
    // 加密邮箱
    let beforeStr=value.split("@")[0];
    let afterStr=value.split("@")[1];
    return beforeStr.substr(0,3)+"**"+beforeStr.substr(beforeStr.length-1,1)+"@"+afterStr;
  }else{
    // 加密手机号码
    return value.substr(0,3)+"****"+value.substr(7,4);
  }
}
class AccountSecure extends Component {
  constructor (props) {
    super(props)
    this.state = {
      updating: ''
    }
  }

  // 获取验证码
  getCode=(index)=>{
    let url=`/account/get_verification_code.json`
    if(index == 3){
      //绑定手机号码
      let values=this.props.form.getFieldsValue();
      console.log(values);
    }
  }

  onPhoneSubmit = () => {
    this.props.form.validateFieldsAndScroll((err, values) => {
      if (!err) {
        let {login}=this.props.current_user;
        let reg=/^1\d{10}$/;
        if(reg.test(values.phone)){
          let url=`/users/accounts/${login}/phone_bind.json`
          axios.post((url),{
            phone:values.phone,
            code:values.phoneValidateCode
          }).then((result)=>{
            if(result){
              this.props.showNotification("手机号码绑定成功!");
              this.setState({
                updating:''
              })
              this.props.getBasicInfo();
            }
          }).catch((error)=>{
            console.log(error);
          })
        }else{
          this.props.showNotification("请输入有效的11位手机号码");
        }
      }
    })
  }
  onEmailSubmit = () => {
    this.props.form.validateFieldsAndScroll((err, values) => {
      if (!err) {

      }
    })
  }
  onPasswordSubmit = () => {
    this.props.form.validateFieldsAndScroll((err, values) => {
      if (!err) {

      }
    })
  }

  //取消编辑
  hideUpdating=()=>{
    this.setState({
      updating:""
    })
  }

  render() {
    let {basicInfo}=this.props;
    const { getFieldDecorator } = this.props.form;
    const { updating } = this.state
    return (
      <div className="basicFormWrap">

        <div className="basicForm settingForm">
          <style>{`

            .flexRow {
              padding: 20px 0;
            }
              .flexRow .name {
                margin-left: 12px;
                color: #999999;

                text-align: center;
                flex: 0 0 100px;
              }
              .flexRow .description {
                margin-left: 10px;
                flex: 1;
                color: #CDCDCD;
              }
                .description span {
                  margin-right: 8px;
                  color: #05101A;
                }
              .flexRow .status {
                width: 100px;
                color: #28AC7F;
                text-align: right;
              }
            .flexTable .flexTable {
              border-bottom: 1px solid #EBEBEB;
            }
            

            .settingForm label{
              color: #999999;
              font-size: 14px !important ; 
              margin-left: 120px;
            }
            .settingForm input {
              width: 340px;
            }
            .settingForm input.validateInput  {
              width: 220px;
            }
            .settingForm .formItemInline button {
              width: 110px;
              margin-left: 10px;
            }

            .settingForm .ant-form-item-label {
              width: 204px;
            }
            .formItemInline .ant-form-explain{
              position:absolute;
              bottom:-17px;
              left:0px;
              width:100%;
            }
          `}</style>
          <div className="title">安全设置</div>
          <Form>
          <div className="flexTable">
            <div className="flexTable">
              <div className="flexRow">
                <div className="name">手机</div>
                <div className="description">
                  {
                    basicInfo && basicInfo.phone ?
                    <span>{ regPhoneAndEmail(basicInfo.phone) }</span>
                    :
                    <span style={{color: '#EA320E'}}>未绑定</span>
                  }
                  绑定手机号码，将获得500金币的奖励哟～，手机号码仅自己可见~ 
                </div>
                {
                  updating != PHONE &&
                  <div className="status">
                    <WordsBtn style="blue" className="borderBottom" 
                        onClick={() => this.setState({updating: PHONE})}
                    >{basicInfo && basicInfo.phone ? "更换" : "立即绑定" }</WordsBtn>
                  </div>
                }
              </div>
              
              { updating == PHONE && 
              <React.Fragment>
              <Form.Item
                label="你的手机号"
                className="formItemInline hideRequireTag mb20"
              >
                {getFieldDecorator('phone', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请输入要绑定的手机号码',
                  }],
                })(
                  <Input placeholder="请输入要绑定的手机号码"></Input>
                )}
              </Form.Item>

              <Form.Item
                label="手机验证码"
                className="mb20 formItemInline hideRequireTag"
              >
                {getFieldDecorator('phoneValidateCode', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请输入手机获取的验证码',
                  }],
                })(
                  <Input placeholder="请输入手机获取的验证码" className="validateInput"></Input>
                )}
                <Button type="primary" onClick={()=>this.getCode(3)}>获取验证码</Button>
              </Form.Item>

              <div className="mb20" style={{ marginLeft: '118px' }}>
                <Button type="primary" onClick={this.onPhoneSubmit}>确定</Button>
                <Button type="primary grayBtn" style={{ marginLeft: '20px'}} onClick={this.hideUpdating}>取消</Button>
              </div>
              </React.Fragment> }
            </div>
            
            <div className="flexTable">
              <div className="flexRow">
                <div className="name">邮箱</div>
                <div className="description">
                  {
                    basicInfo && basicInfo.mail ?
                    <span>{ regPhoneAndEmail(basicInfo.mail) }</span>
                    :
                    <span style={{color: '#EA320E'}}>未绑定</span>
                  }
                  邮箱账号仅自己可见，可用于邮箱账号登录EduCoder 
                </div>
                {
                  updating != EMAIL &&
                  <div className="status">
                    <WordsBtn style="blue" className="borderBottom"
                      onClick={() => this.setState({updating: EMAIL})}
                    >{basicInfo && basicInfo.mail ?"更换":"立即绑定"}</WordsBtn>
                  </div>
                }
              </div>  
              
              { updating == EMAIL && 
              <React.Fragment>
              <Form.Item
                label="邮箱地址"
                className="formItemInline hideRequireTag mb20"
              >
                {getFieldDecorator('phone', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请输入要更换的新邮箱地址',
                  }],
                })(
                  <Input placeholder="请输入要更换的新邮箱地址"></Input>
                )}
              </Form.Item>

              <Form.Item
                label="邮箱验证码"
                className="mb20 formItemInline hideRequireTag"
              >
                {getFieldDecorator('phoneValidateCode', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请输入邮箱收到的验证码',
                  }],
                })(
                  <Input placeholder="请输入邮箱收到的验证码" className="validateInput"></Input>
                )}
                <Button type="primary">获取验证码</Button>
              </Form.Item>

              <div className="mb20" style={{ marginLeft: '118px' }}>
                <Button type="primary" onClick={this.onEmailSubmit}>确定</Button>
                <Button type="primary grayBtn" style={{ marginLeft: '20px'}} onClick={this.hideUpdating}>取消</Button>
              </div>
              </React.Fragment>  }

            </div>


            <div className="flexTable">
              <div className="flexRow">
                <div className="name">密码</div>
                <div className="description">
                  <span>**********</span>
                  用于保护账户信息和登录安全 
                </div>
                { 
                  updating != PASSWORD &&
                  <div className="status">
                    <WordsBtn style="blue" className="borderBottom"
                        onClick={() => this.setState({updating: PASSWORD})}
                    >修改</WordsBtn>
                  </div>
                }
              </div> 
              
              { updating == PASSWORD && 
              <React.Fragment>
              <Form.Item
                label="旧密码"
                className="mb20 formItemInline hideRequireTag"
              >
                {getFieldDecorator('p_old', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请设置8～16位密码，区分大小写',
                  }],
                })(
                  <Input type="password" placeholder="请设置8～16位密码，区分大小写"></Input>
                )}
              </Form.Item>

              <Form.Item
                label="新密码"
                className="mb20 formItemInline hideRequireTag"
              >
                {getFieldDecorator('p_new', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请设置8～16位密码，区分大小写',
                  }],
                })(
                  <Input type="password" placeholder="请设置8～16位密码，区分大小写" className="validateInput"></Input>
                )}
              </Form.Item>

              <Form.Item
                label="再次输入"
                className="mb20 formItemInline hideRequireTag"
              >
                {getFieldDecorator('p_again', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请再次输入新密码',
                  }],
                })(
                  <Input type="password" placeholder="请再次输入新密码" className="validateInput"></Input>
                )}
              </Form.Item>

              <div className="mb20" style={{ marginLeft: '118px' }}>
                <Button type="primary" onClick={this.onPasswordSubmit}>确定</Button>
                <Button type="primary grayBtn" style={{ marginLeft: '20px'}} onClick={this.hideUpdating}>取消</Button>
              </div>
              </React.Fragment> }
            </div>

          </div>
          </Form>
        </div>
        <diV style={{color: '#989898', marginLeft: '20px'}}>* 我们确保你所提供的信息均处于严格保密状态，不会泄露</diV>
      </div>
    );
  }
}
const WrappedAccountSecure = Form.create({ name: 'AccountSecure' })(AccountSecure);

export default WrappedAccountSecure;
